import os

# This script goes through loadin blendfiles and reporting any library errors they have in a useful way
# Run every once in a while to chack the validity of the movies blend files

tempf = '/tmp/blenLibChecker.temp'
blends = '/tmp/blenLibCheckerFiles.temp'
search = '/media/data/peach/production'


def main():
	os.system('find %s -name "*.blend" > %s' % (search, blends))

	file_blends = open(blends, 'r').readlines()
	
	
	errors = {}
	error_count = 0
	error_path = []
	tot = len(file_blends)
	for i, line in enumerate(file_blends):
		line = line.strip()
		print 'Loading', line, str(int( (float(i)/tot) * 100.0 )) + '% done,  error count:', error_count
		
		line = line.strip()
		#os.system('export ')
		
		
		# RUN Blender to find Library errors AND run a script that looks broken paths!
		## os.system('LD_LIBRARY_PATH=/shared/software/exr/lib /render/blender_$(whoami)/blender/blender -b %s 1> %s 2>&1' % (line, tempf))
		
		
		pyscript = search + '/scripts/findPathError.py'
		# Also run a py script
		os.system('LD_LIBRARY_PATH=/shared/software/exr/lib /render/blender_$(whoami)/blender/blender -b %s   -P %s   1> %s 2>&1' % (line, pyscript, tempf))
		
		
		
		#os.system('/render/blender_$(whoami)/blender/blender -b %s')
		file_lib = open(tempf, 'r')
		
		context_lib = None
		for out_line in file_lib.readlines():
			if out_line.startswith('ERROR PATH: ') or out_line.startswith('ABSOLUTE PATH: '): # Py Script makes this one
				context_lib = out_line.strip()
				errors.setdefault(line, ({}, []))[1].append(out_line.strip())
				error_count += 1
			elif out_line.startswith('read library: '):
				context_lib = out_line.strip()
			elif out_line.startswith('LIB ERROR: '):
				errors.setdefault(line, ({}, []))[0].setdefault(context_lib, []).append(out_line.strip())
				error_count += 1
	
	
	# Repor errors
	for blenfile, blenfile_dict_and_pics in errors.iteritems():
		print 'BLENFILE:', blenfile
		for libfile, errorls in blenfile_dict_and_pics[0].iteritems():
			print '\tLIBFILE:', libfile
			for err in errorls:
				print '\t\t:', err
		for file in blenfile_dict_and_pics[1]:
			print '\t%s' % file
				
			
		
	os.system('rm ' + tempf)
	os.system('rm ' + blends)
	

main()
		
		
		
		