#!/usr/bin/python
# Sorts images into dirs
import os
RENDER='/shared/render/'

def file_split(f):
	# 10_chinchilla-03_0001.exr -> 10_chinchilla, 03
	# 
	
	f = f.replace('.exr', '')
	frame = f.split('_')[-1]
	f = f[:-(len(frame)+1)]
	shot = f.split('-')[-1]
	f = f[:-(len(shot)+1)]
	return f, shot, frame

def filename_2_path(f):
	f, shot, frame = file_split(f)
	path = os.path.join(RENDER, f)
	path = os.path.join(path, shot)
	return path

def main():
	files = [f for f in os.listdir(RENDER) if f.endswith('.exr')]
	
	for f in files:
		path_from = os.path.join(RENDER, f)
		path_to = os.path.join(filename_2_path(f), 'exr')
		path_old = os.path.join(path_to, 'old/')
		path_existing_dont_overwrite = os.path.join(path_to, f)
		if os.path.exists( path_existing_dont_overwrite ):
			os.system( 'mkdirhier %s' % path_old )
			os.system( 'mv %s %s' % (path_existing_dont_overwrite, path_old) )
		
		# Make 
		os.system( 'mkdirhier %s' % path_to )
		move_cmd = 'mv %s %s' % (path_from, path_to)
		
		print 'mv %s %s' % (path_from, path_to)
		os.system( move_cmd )


main()
